



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ML.NET 示例：推荐之One Class 矩阵分解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ML.NET 示例：推荐之One Class 矩阵分解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 12:26:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><h2>写在前面</h2>
<p>准备近期将微软的machinelearning-samples翻译成中文，水平有限，如有错漏，请大家多多指正。<br /><br />
如果有朋友对此感兴趣，可以加入我：<a href="https://github.com/feiyun0112/machinelearning-samples.zh-cn" rel="external nofollow noreferrer">https://github.com/feiyun0112/machinelearning-samples.zh-cn</a></p></blockquote>
<h1>产品推荐 - 矩阵分解问题示例</h1>
<table>
<thead>
<tr>
<th>ML.NET 版本</th>
<th>API 类型</th>
<th>状态</th>
<th>应用程序类型</th>
<th>数据类型</th>
<th>场景</th>
<th>机器学习任务</th>
<th>算法</th>
</tr>
</thead>
<tbody>
<tr>
<td>v0.8</td>
<td>动态 API</td>
<td>最新版本</td>
<td>控制台应用程序</td>
<td>.txt 文件</td>
<td>推荐</td>
<td>矩阵分解</td>
<td>MatrixFactorizationTrainer (One Class)</td>
</tr>
</tbody>
</table>
<p>在这个示例中，您可以看到如何使用ML.NET来构建产品推荐方案。</p>
<p>本示例中的推荐方式基于共同购买或经常一起购买的产品，这意味着它将根据客户的购买历史向客户推荐一组产品。</p>
<p><img referrerpolicy="no-referrer"src="https://raw.githubusercontent.com/dotnet/machinelearning-samples/master/samples/csharp/getting-started/MatrixFactorization_ProductRecommendation/ProductRecommender/Data/frequentlyboughttogether.png"></p>
<p>在这个示例中，基于经常一起购买的学习模型来推荐产品。</p>
<h2>问题</h2>
<p>在本教程中，我们将使用亚马逊共同购买产品数据集。</p>
<p>我们将使用One-Class因式分解机来构建我们的产品推荐器，它使用协同过滤方法。</p>
<p>我们介绍的one-class和其他因式分解机的区别在于，在这个数据集中，我们只有购买历史的信息。</p>
<p>我们没有评分或其他详细信息，如产品描述等。</p>
<p>“协同过滤”是在一个基本假设的情况下运作的，即如果某人A在一个问题上与某人B具有相同的意见，则在另一个问题上，相对其他随机选择的人，A更倾向于B的观点。</p>
<h2>数据集</h2>
<p>原始数据来自SNAP:<br /><br />
<a href="https://snap.stanford.edu/data/amazon0302.html" rel="external nofollow noreferrer">https://snap.stanford.edu/data/amazon0302.html</a></p>
<h2>ML 任务 - <a href="https://docs.microsoft.com/en-us/dotnet/machine-learning/resources/tasks#recommendation" rel="external nofollow noreferrer">矩阵分解 (推荐)</a></h2>
<p>这个示例的ML任务是矩阵分解，它是一个执行协同过滤的有监督的机器学习任务。</p>
<h2>解决方案</h2>
<p>要解决此问题，您需要在现有训练数据上建立和训练ML模型，评估其有多好（分析获得的指标），最后您可以使用/测试模型来预测给定输入数据变量的需求。</p>
<p><img referrerpolicy="no-referrer"src="https://raw.githubusercontent.com/feiyun0112/machinelearning-samples.zh-cn/master/samples/csharp/getting-started/shared_content/modelpipeline.png"></p>
<h3>1. 建立模型</h3>
<p>建立模型包括:</p>
<ul><li><p>从 <a href="https://snap.stanford.edu/data/amazon0302.html" rel="external nofollow noreferrer">https://snap.stanford.edu/data/amazon0302.html</a> 下载并复制数据集文件Amazon0302.txt。</p></li>
<li><p>使用以下内容替换列名：ProductID	ProductID_Copurchased</p></li>
<li><p>在读取器中，我们已经提供了KeyRange，并且产品ID已经编码，我们需要做的就是使用几个额外的参数调用MatrixFactorizationTrainer。</p></li></ul>
<p>下面是用于建立模型的代码：</p>
<pre class="prettyprint linenums"><code><br />
    //STEP 1: Create MLContext to be shared across the model creation workflow objects<br />
    var ctx = new MLContext();

    //STEP 2: Create a reader by defining the schema for reading the product co-purchase dataset<br />
    //        Do remember to replace amazon0302.txt with dataset from<br />
              https://snap.stanford.edu/data/amazon0302.html<br />
    var reader = ctx.Data.TextReader(new TextLoader.Arguments()<br />
    {<br />
        Separator = &quot;tab&quot;,<br />
        HasHeader = true,<br />
        Column = new[]<br />
        {<br />
                new TextLoader.Column(&quot;Label&quot;, DataKind.R4, 0),<br />
                new TextLoader.Column(&quot;ProductID&quot;, DataKind.U4, new [] { new TextLoader.Range(0) }, new KeyRange(0, 262110)),<br />
                new TextLoader.Column(&quot;CoPurchaseProductID&quot;, DataKind.U4, new [] { new TextLoader.Range(1) }, new KeyRange(0, 262110))<br />
            }<br />
        });

        //STEP 3: Read the training data which will be used to train the movie recommendation model<br />
        var traindata = reader.Read(new MultiFileSource(TrainingDataLocation));

        //STEP 4: Your data is already encoded so all you need to do is call the MatrixFactorization Trainer with a few extra hyperparameters:<br />
        //        LossFunction, Alpa, Lambda and a few others like K and C as shown below.<br />
        var est = ctx.Recommendation().Trainers.MatrixFactorization(&quot;ProductID&quot;, &quot;CoPurchaseProductID&quot;,<br />
                                     labelColumn: &quot;Label&quot;,<br />
                                     advancedSettings: s =&gt;<br />
                                     {<br />
                                         s.LossFunction = MatrixFactorizationTrainer.LossFunctionType.SquareLossOneClass;<br />
                                         s.Alpha = 0.01;<br />
                                         s.Lambda = 0.025;<br />
                                         // For better results use the following parameters<br />
                                         //s.K = 100;<br />
                                         //s.C = 0.00001;<br />
                                     });<br />
</code></pre>
<h3>2. 训练模型</h3>
<p>一旦定义了评估器，就可以根据可用的训练数据对评估器进行训练。</p>
<p>这将返回一个训练过的模型。</p>
<pre class="prettyprint linenums"><code><br />
    //STEP 5: Train the model fitting to the DataSet<br />
    //Please add Amazon0302.txt dataset from https://snap.stanford.edu/data/amazon0302.html to Data folder if FileNotFoundException is thrown.<br />
    var model = est.Fit(traindata);

</code></pre>
<h3>3. 使用模型</h3>
<p>我们将通过创建预测引擎/函数来执行此模型的预测，如下所示。</p>
<pre class="prettyprint linenums"><code>    public class Copurchase_prediction<br />
    {<br />
        public float Score { get; set; }<br />
    }

    public class ProductEntry<br />
    {<br />
        [KeyType(Contiguous = true, Count = 262111, Min = 0)]<br />
        public uint ProductID { get; set; }

        [KeyType(Contiguous = true, Count = 262111, Min = 0)]<br />
        public uint CoPurchaseProductID { get; set; }<br />
        }<br />
</code></pre>
<p>一旦创建了预测引擎，就可以预测两个产品被共同购买的分数。</p>
<pre class="prettyprint linenums"><code>    //STEP 6: Create prediction engine and predict the score for Product 63 being co-purchased with Product 3.<br />
    //        The higher the score the higher the probability for this particular productID being co-purchased<br />
    var predictionengine = model.MakePredictionFunction&lt;ProductEntry, Copurchase_prediction&gt;(ctx);<br />
    var prediction = predictionengine.Predict(<br />
                             new ProductEntry()<br />
                             {<br />
                             ProductID = 3,<br />
                             CoPurchaseProductID = 63<br />
                             });<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq477e0q.html">一步一步hadoop安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96lg6y9.html">linux-dns服务器搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdrkyx8.html">解决MVC EF Code First错误&colon;Model compatibility cannot be checked because the EdmMetadata type was not included in the model&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901gx38.html">Android-完全退出当前应用程序的四种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p4e679.html">redis在windows中的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4ep5n9.html">如何用Apache POI操作Excel文件-----如何在已有的Excel文件中插入一行新的数据？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdgl048.html">Mybatis学习 &mdash;&mdash; 包括所有 mybatis官网</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdedvmj9.html">effective c&plus;&plus; （二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xk2v9.html">一个Redis实现的分布式锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e16roz9.html">（转）Spring读书笔记-----Spring的Bean之Bean的基本概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdgx1l8.html">&lbrack;转&rsqb; Linux写时拷贝技术&lpar;copy-on-write&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm64xx9.html">web前端之 HTML标签详细介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmz5j09.html">SQLite 终端相关命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgzzj78.html">Android学习资料PDF免费大放送，每日更新！有需要的亲看这里</a>
		</li>
						<li><a href="https://www.batexi.com/a/950p2ov8.html">UAC下的程序权限提升</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpkolzq.html">centos7 安装elasticsearch</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdo7049.html">JVM学习--&lpar;二&rpar;内存模型、可见性、指令重排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgo0je8.html">GOOGLE RANKBRAIN 完整指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1jyde9.html">Codeforces Round &num;245 &lpar;Div&period; 1&rpar;   B&period; Working out  （dp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jpmwjq.html">html-edm&lpar;邮件营销&rpar;编写规则</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwpk4k8.html">惰性求值&mdash;&mdash;lodash源码解读</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll1ngxq.html">Jenkins 安装 on centos7</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25k05oq.html">2016-04-25-信息系统实践手记6-JS调用Flex的性能问题一例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvnye28.html">移动端 input样式在安卓与ios上不同的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7oedzx8.html">如何解决远程连接mysql出现Can&rsquo;t connect to MySQL server on &lpar;111 &OpenCurlyDoubleQuote;Connection refused&rdquo;&rpar;的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjpg6z9.html">Android 模块构建错误不能下载依赖包</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjokxr9.html">windbg调试子进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyvordq.html">mybatis根据数据库表结构自动生成实体类，dao，mapper</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwpv4z8.html">linux中find命令高级用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25kv5vq.html">Java 7 for Absolute Beginners&sol;Java 7基础教程--代码纠错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
